<template>
  <div
    style="
      width: 64%;
      float: left;
      background-color: #d4d4d4;
      padding: 20px;
      box-sizing: border-box;
    "
  >
    <h1>Лента отзывов</h1>

    <OptionSelector
      caption="Сортировать по:"
      :initial-option="selectedSortOption"
      :options="sortOptions"
      @selected="onSortOptionSelected"
      style="margin-bottom: 20px; width: 60%"
    />

    <hr style="margin-top: 80px; background-color: black" />

    <ul style="margin-top: 16px; width: 100%; box-sizing: border-box">
      <li v-for="(review, index) in reviews" :key="index">
        <template v-if="index > 0">
          <hr />
        </template>
        <Review :review="review" />
      </li>
    </ul>
  </div>
  <div
    style="
      width: 36%;
      height: 100%;
      float: right;
      background-color: #b4b4b4;
      padding: 20px;
      box-sizing: border-box;
    "
  >
    <FilterSelector @submit_filter="setFilters" />
  </div>
</template>

<script>
import axios from "axios";

import OptionSelector from "../components/OptionSelector";
import Review from "../components/Review";
import FilterSelector from "../components/FilterSelector";

export default {
  name: "ReviewList.vue",
  components: { FilterSelector, Review, OptionSelector },
  data() {
    let sortOptions = [
      { text: "оценке", value: "score" },
      { text: "дате отзыва", value: "review_date" },
      { text: "году обучения", value: "edu_start" },
    ];
    return {
      reviews: [],
      sortOptions: sortOptions,
      selectedSortOption: sortOptions[0].value,
      filters: [],
      url: String(process.env.VUE_APP_API_URL),
    };
  },
  mounted() {
    this.onSortOptionSelected(this.selectedSortOption);
  },
  methods: {
    setFilters(val) {
      this.filters = val;
      this.onSortOptionSelected(this.selectedSortOption);
    },
    onSortOptionSelected(option) {
      this.selectedSortOption = option;
      const params = [
        this.selectedSortOption == null
          ? ""
          : "order_by=" + String(this.selectedSortOption),
        ...this.filters,
      ].join("&");

      axios
        .get(this.url + "reviews" + (params === "" ? "" : "?" + params))
        .then((response) => (this.reviews = response.data.reviewList));
    },
  },
};
</script>

<style>
.caption {
  float: left;
  margin-right: 16px;
  box-sizing: border-box;
  padding: 5px;
}

.selector {
  float: right;
  margin-left: auto;
  margin-right: 5px;
  width: 48%;
}

.selector_container {
  box-sizing: border-box;
  float: left;
  width: 100%;
  margin-top: 10px;
  margin-bottom: 10px;
}
</style>

<style scoped>
h1 {
  margin-bottom: 20px;
}
</style>
